package hvqzao.flow.ui;

import burp.IBurpExtenderCallbacks;
import burp.IExtensionHelpers;
import hvqzao.flow.FlowExtension;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JTextArea;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultCaret;

public class Editor extends javax.swing.JPanel implements IEditor {

    private DefaultCaret caret;
    private IExtensionHelpers helpers;
    private int searchIndex;

    /**
     * Creates new form Editor
     */
    public Editor() {
        initComponents();
        searchIndex = -1;
        next.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String searchText = search.getText().toLowerCase();
                final int searchTextLength = searchText.length();
                if (searchTextLength > 0) {
                    String message = editor.getText().toLowerCase();
                    int result;
                    if (searchIndex == -1) {
                        result = message.indexOf(searchText);
                    } else {
                        result = message.indexOf(searchText, searchIndex);
                        if (result == -1) {
                            result = message.indexOf(searchText);
                        }
                    }
                    final int pos = result;
                    if (pos != -1) {
                        searchIndex = pos + 1;
                        editor.requestFocusInWindow();
                        Rectangle viewRect;
                        try {
                            viewRect = editor.modelToView(pos);
                        } catch (BadLocationException ex) {
                            ex.printStackTrace(FlowExtension.getStderr());
                            return;
                        }
                        editor.scrollRectToVisible(viewRect);
                        editor.setCaretPosition(pos + searchTextLength);
                        editor.moveCaretPosition(pos);
                    }
                }
            }
        });
        prev.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String searchText = search.getText().toLowerCase();
                final int searchTextLength = searchText.length();
                if (searchTextLength > 0) {
                    String message = editor.getText().toLowerCase();
                    int result;
                    if (searchIndex < 2) {
                        result = message.lastIndexOf(searchText);
                    } else {
                        result = message.lastIndexOf(searchText, searchIndex - 2);
                        if (result == -1) {
                            result = message.lastIndexOf(searchText);
                        }
                    }
                    final int pos = result;
                    if (pos != -1) {
                        searchIndex = pos + 1;
                        editor.requestFocusInWindow();
                        Rectangle viewRect;
                        try {
                            viewRect = editor.modelToView(pos);
                        } catch (BadLocationException ex) {
                            ex.printStackTrace(FlowExtension.getStderr());
                            return;
                        }
                        editor.scrollRectToVisible(viewRect);
                        editor.setCaretPosition(pos + searchTextLength);
                        editor.moveCaretPosition(pos);
                    }
                }
            }
        });
    }

    @Override
    public boolean hasFocus() {
        return editor.hasFocus();
    }

    @Override
    public void customizeUiComponent(final IBurpExtenderCallbacks callbacks) {
        helpers = callbacks.getHelpers();
        callbacks.customizeUiComponent(editor);
        callbacks.customizeUiComponent(prev);
        callbacks.customizeUiComponent(next);
        callbacks.customizeUiComponent(search);
        editor.setFont(new Font("monospaced", Font.PLAIN, 11));
    }

    @Override
    public void setText(byte[] message) {
        caret = (DefaultCaret) editor.getCaret();
        caret.setUpdatePolicy(DefaultCaret.NEVER_UPDATE);
        if (message != null) {
            editor.setText(helpers.bytesToString(message));
        }
        caret.setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);
        searchIndex = -1;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane5 = new javax.swing.JScrollPane();
        editor = new javax.swing.JTextArea();
        prev = new javax.swing.JButton();
        next = new javax.swing.JButton();
        search = new javax.swing.JTextField();

        editor.setEditable(false);
        editor.setColumns(20);
        editor.setLineWrap(true);
        editor.setRows(5);
        editor.setToolTipText(null);
        jScrollPane5.setViewportView(editor);

        prev.setText("<");

        next.setText(">");

        search.setToolTipText(null);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 329, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(prev)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(next)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(search))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE)
                .addGap(0, 0, 0)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(search, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(prev)
                    .addComponent(next)))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea editor;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JButton next;
    private javax.swing.JButton prev;
    private javax.swing.JTextField search;
    // End of variables declaration//GEN-END:variables

    @Override
    public JTextArea getEditor() {
        return editor;
    }
}
